(*|  0:45  3/01/1998 *)
(* v1.3 from v1.2; Inst[9] replaced by sine *)
(*| 22:59 17/11/1997 *)
(* v1.2 from v1.10; CONST InstType/Inst added, NewInst() *)
(* TVolChange - LeftUp,LeftDown,RightUp,RightDown added *)
(* NewInt9 modified for NewInst() and ChangeVol *)
(*| 21:57 22/06/1996 *)
PROGRAM BWOrgan;

USES
  Crt,Dos,BWDrive;

CONST
  { instrument table }
  { InstType
       Modulator Sound Characteristic - AM_VIB_EG_KSR_Multiple
       Carrier Sound Characteristic
       Modulator Scaling/Output Level - KSL_TotalLevel
       Carrier Scaling/Output Level
       Modulator Attack/Decay         - Attack_Decay
       Carrier Attack/Decay
       Modulator Sustain Level/Release Rate - Sustain_Release
       Carrier Sustain Level/Release Rate
       Modulator Wave Select         - WaveSelect
       Carrier Wave Select
       FeedBackConnection            - FeedBack_Connect
       Spare x 5
  }
  Inst : ARRAY[0..9] OF InstType =
                ( ( $21,$11,$4c,$00,$f1,$f2,$63,$72,
                    $00,$00,$04,$00,$00,$00,$00,$00 ),  { 0 = piano }

                  ( $a5,$b1,$d2,$80,$81,$f1,$03,$05,
                    $00,$00,$02,$00,$00,$00,$00,$00 ),

                  ( $71,$62,$1c,$05,$51,$52,$03,$13,
                    $00,$00,$0e,$00,$00,$00,$00,$00 ),  { 2 = organ }

                  ( $11,$01,$8a,$40,$f1,$f1,$11,$b3,
                    $00,$00,$06,$00,$00,$00,$00,$00 ),

                  ( $21,$11,$11,$00,$a3,$c4,$43,$22,
                    $02,$00,$0d,$00,$00,$00,$00,$00 ),

                  ( $31,$a1,$1c,$80,$41,$92,$0b,$3b,
                    $00,$00,$0e,$00,$00,$00,$00,$00 ),

                  ( $71,$62,$c5,$05,$6e,$8b,$17,$0e,
                    $00,$00,$02,$00,$00,$00,$00,$00 ),  { 6 = organ }

                  ( $41,$91,$83,$00,$65,$32,$05,$74,
                    $00,$00,$0a,$00,$00,$00,$00,$00 ),

                  ( $32,$16,$87,$80,$a1,$7d,$10,$33,
                    $00,$00,$08,$00,$00,$00,$00,$00 ),  { 8 = harpsicord }
(*
                  ( $01,$13,$8d,$00,$51,$52,$53,$7c,
                    $01,$00,$0c,$00,$00,$00,$00,$00 ) );
*)
                  ( $20,$21,$3F,$00,$44,$FF,$0C,$0C,
                    $00,$00,$01,$00,$00,$00,$00,$00 ) ); { 9 = sine }

CONST
  MaxInst =9;
  SBCardBase = $220;
  HexAscii: ARRAY[0..15] OF CHAR = '0123456789ABCDEF';
TYPE
  TKeyClass = (WhiteKey,HalfWhiteKey,BlackKey);
  TVolChange = (VolUp,VolDown,LeftUp,LeftDown,RightUp,RightDown);
  TVolClass = (MasterVol,MidiVol,CDVol,LineVol);
  TOnKeyInfo = RECORD
    OnScan : Byte;
    OnNote : Byte;
    OnOct  : Byte;
  END;
  TVolumes = RECORD
    Vols : ARRAY[TVolClass] OF BYTE;
  END;

VAR
  Done : Boolean;
  ExitSave,OldInt9Vec,VidPtr: Pointer;
  Oct: Integer;
  OnKeyInfo : Array[1..MaxInst] OF TOnKeyInfo;
  NumKeysOn : Integer;
  VideoRam : Byte Absolute $B800:1600;
  Volumes: TVolumes;

{$F+}                         { This function uses the FAR call model }
PROCEDURE PianoKeys; External; {$L PianoKey.Obj}

FUNCTION SetTypm( Rate : byte ) : Boolean;

BEGIN
 INLINE(
        $32/$D2/$B4/$F3/$FA/$E8/$13/$00/$75/$0A/$8A/$66/$06/$E8/
        $0B/$00/$75/$02/$FE/$C2/$FB/$88/$56/$FF/$EB/$27/$90/$51/
        $53/$B3/$03/$33/$C9/$E4/$64/$A8/$02/$E0/$FA/$8A/$C4/$E6/
        $60/$E4/$64/$A8/$01/$E1/$FA/$E4/$60/$3C/$FA/$74/$07/$FE/
        $CB/$75/$E6/$80/$CB/$01/$5B/$59/$C3
       );
END;  { SetTypm }
{$F-}

(****
PROCEDURE JumpToOldIsr(OldIsr : Pointer);
  {-Jump to previous ISR from an interrupt procedure.}
  INLINE(
    $5B/                     {pop bx          ;BX = Ofs(OldIsr)}
    $58/                     {pop ax          ;AX = Seg(OldIsr)}
    $87/$5E/$0E/             {xchg bx,[bp+14] ;Switch old BX and Ofs(OldIsr)}
    $87/$46/$10/             {xchg ax,[bp+16] ;Switch old AX and Seg(OldIsr)}
    $89/$EC/                 {mov sp,bp       ;Restore SP}
    $5D/                     {pop bp          ;Restore BP}
    $07/                     {pop es          ;Restore ES}
    $1F/                     {pop ds          ;Restore DS}
    $5F/                     {pop di          ;Restore DI}
    $5E/                     {pop si          ;Restore SI}
    $5A/                     {pop dx          ;Restore DX}
    $59/                     {pop cx          ;Restore CX}
                             {;BX and AX restored earlier; their places on stack}
                             {;now have OldIsr, which is where return will go}
    $CB);                    {retf            ;Chain to OldIsr}
****)

{$S-}

PROCEDURE NewInst(I: Integer);
VAR
  N: Integer;
  O: Word;
BEGIN
  FOR N := 1 TO 9 DO
    LoadInstrument(N, Inst[I]);
  O := 160*2 + 120;
  Mem[$B800:O] := I+$30;
END;

PROCEDURE GetVolumes;
VAR
  W1,W2: WORD;
  I: BYTE;
BEGIN
  W1 := SBCardBase + 4;
  W2 := SBCardBAse + 5;
  WITH Volumes DO BEGIN
    Port[W1]        := $22;
    Vols[MasterVol] := Port[W2];
    Port[W1]        := $26;
    Vols[MidiVol]   := Port[W2];
    Port[W1]        := $28;
    Vols[CDVol]     := Port[W2];
    Port[W1]        := $2E;
    Vols[LineVol]   := Port[W2];
  END;
END;

PROCEDURE SetVolumes;
VAR
  W1,W2: WORD;
  I: BYTE;
BEGIN
  W1 := SBCardBase + 4;
  W2 := SBCardBAse + 5;
  WITH Volumes DO BEGIN
    Port[W1]  := $22;
    Port[W2]  := Vols[MasterVol];
    Port[W1]  := $26;
    Port[W2]  := Vols[MidiVol];
    Port[W1]  := $28;
    Port[W2]  := Vols[CDVol];
    Port[W1]  := $2E;
    Port[W2]  := Vols[LineVol];
  END;
END;

PROCEDURE HexOut(VAR O: WORD; B: Byte);
BEGIN
  Mem[$B800:O] := ORD(HexAscii[(B SHR 4) AND $F]);
  INC(O,2);
  Mem[$B800:O] := ORD(HexAscii[B AND $F]);
  INC(O,6);
END;

PROCEDURE ShowVolumes;
VAR
  O: Word;
BEGIN
  O := 160*2 + 8;
  WITH Volumes DO BEGIN
    HexOut(O,Vols[MasterVol]);
    HexOut(O,Vols[MidiVol]);
    HexOut(O,Vols[CDVol]);
    HexOut(O,Vols[LineVol]);
  END;
END;

PROCEDURE ChangeVolume(WhichVol: TVolClass; Change: TVolChange);
BEGIN
  GetVolumes;
  WITH Volumes DO BEGIN
    IF Change = RightUp THEN BEGIN
      IF (Vols[WhichVol] AND $0F) < $0F THEN
        INC(Vols[WhichVol])
    END ELSE IF Change = RightDown THEN BEGIN
      IF (Vols[WhichVol] AND $0F) > $00 THEN
        DEC(Vols[WhichVol])
    END ELSE IF Change = LeftUp THEN BEGIN
      IF (Vols[WhichVol] AND $F0) < $F0 THEN
        INC(Vols[WhichVol],$10)
    END ELSE IF Change = LeftDown THEN BEGIN
      IF (Vols[WhichVol] AND $F0) > $00 THEN
        DEC(Vols[WhichVol],$10)
    END ELSE IF Change = VolUp THEN BEGIN
      IF Vols[WhichVol] < $F0 THEN
        INC(Vols[WhichVol],$11);
    END ELSE BEGIN
      IF Vols[WhichVol] > $10 THEN
        DEC(Vols[WhichVol],$11);
    END;
  END;
  SetVolumes;
  ShowVolumes;
END;

PROCEDURE ShowOct(Oct: Byte);
VAR
  Offset : Word;
  I: Integer;
BEGIN
  Offset := 1600-160+8+1;
  FOR I := 1 TO 72 DO BEGIN
    Mem[$B800:Offset] := $07;
    Inc(Offset,2);
  END;
  IF Oct = 1 THEN
    Mem[$B800:1600-160+9] := $20
  ELSE IF Oct = 7 THEN
    Mem[$B800:1600-160+149] := $20
  ELSE BEGIN
    Offset := 1600-160+8+1+((Oct-2)*28);
    FOR I := 1 TO 16 DO BEGIN
      Mem[$B800:Offset] := $20;
      Inc(Offset,2);
    END;
  END;
END;

PROCEDURE NoteColour(Offset: Word; Attrib: Byte; KeyClass: TKeyClass);
BEGIN
  IF KeyClass = BlackKey THEN BEGIN
    Mem[$B800:Offset+1] := Attrib SHL 4;
    Mem[$B800:Offset+161] := Attrib SHL 4;
  END ELSE BEGIN
    Mem[$B800:Offset+1] := Attrib;
    Mem[$B800:Offset+161] := Attrib;
    Mem[$B800:Offset+321] := Attrib;
    Mem[$B800:Offset+323] := Attrib;
    Mem[$B800:Offset+481] := Attrib;
    Mem[$B800:Offset+483] := Attrib;
    IF KeyClass = WhiteKey THEN BEGIN
      Mem[$B800:Offset+3] := Attrib;
      Mem[$B800:Offset+163] := Attrib;
    END;
  END;
END;  { NoteColour }

PROCEDURE ColourIt(Oct,Note : Byte; ColourOn: Boolean);
VAR
  KeyClass : TKeyClass;
  Attrib : Byte;
  VidOffset : Word;
BEGIN
  VidOffset := 1600+160+8 + (Note SHL 1) + ((Oct-2)*28);
  IF Oct = 1 THEN
    Inc(VidOffset,28);
  IF Oct = 7 THEN
    Dec(VidOffset,28);
  IF Note > 4 THEN
    Inc(VidOffset,2);
  IF Note > 11 THEN
    Inc(VidOffset,2);
  IF Note IN [1,3,6,8,10] THEN
    KeyClass := BlackKey
  ELSE IF Note IN [4,11] THEN
    KeyClass := WhiteKey
  ELSE
    KeyClass := HalfWhiteKey;
  IF KeyClass = BlackKey THEN BEGIN
    IF ColourOn THEN
      Attrib := Red
    ELSE
      Attrib := Black;
  END ELSE BEGIN
    IF ColourOn THEN
      Attrib := LightGray
    ELSE
      Attrib := White;
  END;
  NoteColour(VidOffset,Attrib,KeyClass);
END;

PROCEDURE NewInt9; INTERRUPT;
VAR
  B, BLo, ThisInst: Byte;
  KeyRelease : Boolean;
BEGIN
  B := Port[$60];
  KeyRelease := (B AND $80) <> 0;
  BLo := B AND $7F;
  Case B OF
    1  : Done := True;
    2  : NewInst(0);
    3  : NewInst(1);
    4  : NewInst(2);
    5  : NewInst(3);
    6  : NewInst(4);
    7  : NewInst(5);
    8  : NewInst(6);
    9  : NewInst(7);
    10 : NewInst(8);
    11 : NewInst(9);
(*
    2  : NoteColour(1600+160+8,LightGray,HalfWhiteKey);
    3  : NoteColour(1600+160+8,White,HalfWhiteKey);
    4  : NoteColour(1600+160+16,LightGray,WhiteKey);
    5  : NoteColour(1600+160+16,White,WhiteKey);
    6  : NoteColour(1600+160+12,Red,BlackKey);
    7  : NoteColour(1600+160+12,Black,BlackKey);
*)
    71 : ChangeVolume(MasterVol,VolUp);
    72 : ChangeVolume(MidiVol,VolUp);
    73 : ChangeVolume(MasterVol,RightUp);
    75 : IF Oct > 1 THEN BEGIN
           Dec(Oct);
           ShowOct(Oct);
         END;
    77 : IF Oct < 7 THEN BEGIN
           Inc(Oct);
           ShowOct(Oct);
         END;
    79 : ChangeVolume(MasterVol,VolDown);
    80 : ChangeVolume(MidiVol,VolDown);
    81 : ChangeVolume(MasterVol,RightDown);
    ELSE IF (BLo >= 31) AND (BLo <= 53) THEN BEGIN
      IF KeyRelease THEN BEGIN
        IF NumKeysOn > 0 THEN BEGIN
          ThisInst := MaxInst;
          WHILE ((ThisInst > 0) AND (OnKeyInfo[ThisInst].OnScan <> BLo)) DO
            Dec(ThisInst);
          IF ThisInst > 0 THEN WITH OnKeyInfo[ThisInst] DO BEGIN
            NoteOff(ThisInst,OnOct,OnNote);
            ColourIt(OnOct,OnNote,False);
            OnScan := 0;
            OnNote := 0;
            OnOct := 0;
{           Write('f',ThisInst);}
            Dec(NumKeySOn);
          END;
        END;
      END ELSE IF NumKeysOn < MaxInst THEN BEGIN
        ThisInst := MaxInst;
        WHILE ((ThisInst > 0) AND (OnKeyInfo[ThisInst].OnScan <> BLo)) DO
          Dec(ThisInst);
        IF ThisInst = 0 THEN BEGIN
          REPEAT
            Inc(ThisInst);
          UNTIL ((ThisInst > MaxInst) OR (OnKeyInfo[ThisInst].OnScan = 0));
          IF ThisInst <= MaxInst THEN WITH OnKeyInfo[ThisInst] DO BEGIN
            OnScan := BLo;
            IF BLo >=44 THEN BEGIN
              OnNote := (BLo-44) SHL 1;
              IF BLo > 46 THEN
                Dec(OnNote);
              IF BLo > 50 THEN
                Dec(OnNote);
            END ELSE BEGIN
              OnNote := Succ((BLo-31) SHL 1);
              IF BLo > 33 THEN
                Dec(OnNote);
              IF BLo > 37 THEN
                Dec(OnNote);
            END;
            OnOct  := Oct;
            IF (OnNote > 12) AND (OnOct < 5) THEN BEGIN
              Dec(OnNote,12);
              Inc(OnOct);
            END;
            NoteOn(ThisInst,OnOct,OnNote);
            ColourIt(OnOct,OnNote,True);
            Inc(NumKeysOn);
{           Write('n',ThisInst);}
          END;
        END;
      END;
    END;
  END;
  B := Port[$61];
  Port[$61] := B OR $80;
  Port[$61] := B;
  Port[$20] := $20;
END;
{$S+}

{$F+}
PROCEDURE ExitHandler;
BEGIN
  ExitProc := ExitSave;
  SetIntVec(9,OldInt9Vec);
  IF SetTypm(0) THEN ;
END;  { ExitHandler }
{$F-}

PROCEDURE SwapVectors;
BEGIN
  GetIntVec(9,OldInt9Vec);
  SetIntvec(9,@NewInt9);
  IF SetTypm($7F) THEN;
  ExitSave := ExitProc;
  ExitProc := @ExitHandler;
END;  { SwapVectors }

PROCEDURE Initvars;
VAR
  I: Integer;
BEGIN
  Done := False;
  Oct := 3;
  NumKeysOn := 0;
  FOR I := 1 TO MaxInst DO WITH OnKeyInfo[I] DO BEGIN
    OnScan := 0;
    OnNote := 0;
    OnOct  := 0;
  END;
END;  { Initvars }

BEGIN
  ClrScr;
  Writeln('FMOrgan Program by B Whitnall, v1.3');
  InitVars;
  Oct := 3;
  SwapVectors;
  VidPtr := @PianoKeys;
  Move(VidPtr^,VideoRam,960);
  GetVolumes;
  ShowVolumes;
  ShowOct(Oct);
  NewInst(0);
  REPEAT
  UNTIL Done;
  ClrScr;
END.
